package dirt

import "code.rocketnine.space/tslocum/cview"

const (
	ElementNone = iota
	ElementText
)

type TextData struct {
	Text string
}

type UI struct {
	Rows     []int
	Columns  []int
	Elements []int
	Layout   [][4]int // x, y, columns, rows
	Data     []interface{}
}

func NewUI() *UI {
	return DefaultUI()
}

func DefaultUI() *UI {
	return &UI{
		Elements: []int{ElementText},
		Layout:   [][4]int{{0, 0, 1, 1}},
		Data:     []interface{}{&TextData{Text: "Example text element"}},
	}
}

func (u *UI) Build() *cview.Grid {
	g := cview.NewGrid()

	g.SetRows(u.Rows...)

	g.SetColumns(u.Columns...)

	for i, t := range u.Elements {
		var e cview.Primitive
		e = cview.NewBox()

		if t == ElementText {
			tv := cview.NewTextView()
			d := u.Data[i].(*TextData)
			tv.SetText(d.Text)

			e = tv
		}

		g.AddItem(e, u.Layout[i][1], u.Layout[i][0], u.Layout[i][3], u.Layout[i][2], 0, 0, true)
	}
	return g
}
